declare type QueueTask<T = any> = () => Promise<T>;
export declare class SerialQueue {
    private queue;
    private isPaused;
    private waitToFinish;
    private currentTask?;
    private debug;
    name: string;
    constructor(opt?: {
        name?: string;
        debug?: boolean;
    });
    private performNext;
    enqueue<T>(task: QueueTask<T>, opt?: {
        immediate?: boolean;
        name?: string;
    }): Promise<T>;
    cancelAll(unblock?: boolean): Promise<void>;
    pause(): Promise<void>;
    resume(): void;
    wait(): Promise<unknown>;
}
export {};
